package com.cs.cryptographic;


import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;

public class RC4Crypt
{
	private static RC4Crypt instance = null;
	
	private RC4Crypt()
	{
		
	}
	
	public static RC4Crypt getInstance()
	{
		if(instance == null)
		{
			instance = new RC4Crypt();
		}
		
		return instance;
	}

	public byte[] encrypt(byte[] key, byte[] data) throws Exception {
	    SecretKeySpec secretKey = new SecretKeySpec(key, "ARC4");
	    Cipher cipher = Cipher.getInstance("ARC4", "BC");
	    byte[] encryptedData = new byte[data.length];
	    cipher.init(Cipher.ENCRYPT_MODE, secretKey);
	    int ctLength = cipher.update(data, 0, data.length, encryptedData, 0);
	    ctLength += cipher.doFinal(encryptedData, ctLength);
		return encryptedData;
	}

	public byte[] decrypt(byte[] key, byte[] data) throws Exception {
		
		byte[] decryptedData = new byte[data.length];
		Cipher cipher = Cipher.getInstance("ARC4", "BC");
	    cipher.init(Cipher.DECRYPT_MODE, new SecretKeySpec(key, "ARC4"));
	    int ptLength = cipher.update(data, 0, data.length, decryptedData, 0);
	    ptLength += cipher.doFinal(decryptedData, ptLength);
		return decryptedData;
	}

}
